From dcbf0c4814cb07388ba62b3e97c238bfba827d13 Mon Sep 17 00:00:00 2001
From: Noriko Hosoi <nhosoi@redhat.com>
Date: Fri, 7 Mar 2014 11:48:56 -0800
Subject: [PATCH] Ticket #47735 - e_uniqueid fails to set if an entry is a
 conflict entry

Bug Description:
When an entry is turned to be a conflict entry, its nsUniqueId has
a mdcsn info as a subtype like this:
 nsUniqueId;mdcsn-5319136f000200010000: c5e0d787-a58f11e3-b7f9dfd1-acc3d5e4
In this case, the attribute type is assigned to the berval "type"
as follows:
 type.bv_val = "nsUniqueId;mdcsn-5319136f000200010000"
 type.bv_len = 37
The subtyped stateinfo is processed in str2entry_state_information_from_type,
which modifies type.bv_val to "nsUniqueId", but type.bv_len remains 37.
str2entry_fast has this logic to set e_uniqueid, where the nsUniqueId
with stateinfo fails to set the value to e_uniqueid.
 if ( type.bv_len == 10 &&
      PL_strncasecmp (type.bv_val, "nsUniqueId", type.bv_len) == 0 ){

Fix Description: This patch resets the length of the type with the
basetype length 10 before the if expression is called for setting
e_uniqueid.
---
 ldap/servers/slapd/entry.c | 55 +++++++++++++++++++++++++++-------------------
 1 file changed, 32 insertions(+), 23 deletions(-)

diff --git a/ldap/servers/slapd/entry.c b/ldap/servers/slapd/entry.c
index 9dc94b3..a0e73e9 100644
--- a/ldap/servers/slapd/entry.c
+++ b/ldap/servers/slapd/entry.c
@@ -135,10 +135,18 @@ struct _entry_vattr {
 /*
  * WARNING: s gets butchered... the base type remains.
  */
-void
-str2entry_state_information_from_type(char *s,CSNSet **csnset,CSN **attributedeletioncsn,CSN **maxcsn,int *value_state,int *attr_state)
+static void
+str2entry_state_information_from_type(char *s, ber_len_t *baselen,
+                                      CSNSet **csnset,
+                                      CSN **attributedeletioncsn,
+                                      CSN **maxcsn,
+                                      int *value_state,
+                                      int *attr_state)
 {
 	char *p= strchr(s, ';');
+	if (p && baselen) {
+		*baselen = p - s;
+	}
 	*value_state= VALUE_PRESENT;
 	*attr_state= ATTRIBUTE_PRESENT;
 	while(p!=NULL)
@@ -283,19 +291,20 @@ str2entry_fast( const char *rawdn, const Slapi_RDN *srdn, char *s, int flags, in
 		}
 
 		if ( slapi_ldif_parse_line( s, &type, &value, &freeval ) < 0 ) {
-			LDAPDebug( LDAP_DEBUG_TRACE,
-			    "<= str2entry_fast NULL (parse_line)\n", 0, 0, 0 );
+			LDAPDebug0Args(LDAP_DEBUG_TRACE, "<= str2entry_fast NULL (parse_line)\n");
 			continue;
 		}
 
 		/*
 		 * Extract the attribute and value CSNs from the attribute type.
-		 */		
+		 */
 		csn_free(&attributedeletioncsn); /* JCM - Do this more efficiently */
 		csnset_free(&valuecsnset);
 		value_state= VALUE_NOTFOUND;
 		attr_state= ATTRIBUTE_NOTFOUND;
-		str2entry_state_information_from_type(type.bv_val,&valuecsnset,&attributedeletioncsn,&maxcsn,&value_state,&attr_state);
+		str2entry_state_information_from_type(type.bv_val, &type.bv_len, 
+		                                      &valuecsnset, &attributedeletioncsn,
+		                                      &maxcsn, &value_state, &attr_state);
 		if(!read_stateinfo)
 		{
 			/* We are not maintaining state information */
@@ -433,8 +442,7 @@ str2entry_fast( const char *rawdn, const Slapi_RDN *srdn, char *s, int flags, in
 		}
 
 		/* retrieve uniqueid */
-		if ( type.bv_len == SLAPI_ATTR_UNIQUEID_LENGTH && PL_strncasecmp (type.bv_val, SLAPI_ATTR_UNIQUEID, type.bv_len) == 0 ){
-
+		if ((type.bv_len == SLAPI_ATTR_UNIQUEID_LENGTH) && (PL_strcasecmp (type.bv_val, SLAPI_ATTR_UNIQUEID) == 0)) {
 			if (e->e_uniqueid != NULL){
 				LDAPDebug (LDAP_DEBUG_TRACE, 
 						   "str2entry_fast: entry has multiple uniqueids %s "
@@ -792,22 +800,22 @@ str2entry_dupcheck( const char *rawdn, char *s, int flags, int read_stateinfo )
     char *valuecharptr=NULL;
     struct berval bvvalue;
     int rc;
-	entry_attrs *ea = NULL;
-	int tree_attr_checking = 0;
-	int big_entry_attr_presence_check = 0;
-	int check_for_duplicate_values =
-			( 0 != ( flags & SLAPI_STR2ENTRY_REMOVEDUPVALS ));
-	Slapi_Value *value = 0;
-	CSN *attributedeletioncsn= NULL;
-	CSNSet *valuecsnset= NULL;
-	CSN *maxcsn= NULL;
-	char *normdn = NULL;
-	int strict = 0;
+    entry_attrs *ea = NULL;
+    int tree_attr_checking = 0;
+    int big_entry_attr_presence_check = 0;
+    int check_for_duplicate_values = ( 0 != ( flags & SLAPI_STR2ENTRY_REMOVEDUPVALS ));
+    Slapi_Value *value = 0;
+    CSN *attributedeletioncsn= NULL;
+    CSNSet *valuecsnset= NULL;
+    CSN *maxcsn= NULL;
+    char *normdn = NULL;
+    int strict = 0;
+    ber_len_t typelen;
 
     /* Check if we should be performing strict validation. */
     strict = config_get_dn_validate_strict();
 
-	LDAPDebug( LDAP_DEBUG_TRACE, "=> str2entry_dupcheck\n", 0, 0, 0 );
+    LDAPDebug0Args(LDAP_DEBUG_TRACE, "=> str2entry_dupcheck\n");
 
     e = slapi_entry_alloc();
     slapi_entry_init(e,NULL,NULL);
@@ -848,7 +856,9 @@ str2entry_dupcheck( const char *rawdn, char *s, int flags, int read_stateinfo )
 		csnset_free(&valuecsnset);
 		value_state= VALUE_NOTFOUND;
 		attr_state= VALUE_NOTFOUND;
-		str2entry_state_information_from_type(type,&valuecsnset,&attributedeletioncsn,&maxcsn,&value_state,&attr_state);
+		str2entry_state_information_from_type(type, &typelen,
+		                                      &valuecsnset, &attributedeletioncsn,
+		                                      &maxcsn, &value_state, &attr_state);
 		if(!read_stateinfo)
 		{
 			/* We are not maintaining state information */
@@ -956,8 +966,7 @@ str2entry_dupcheck( const char *rawdn, char *s, int flags, int read_stateinfo )
 		}
 
 		/* retrieve uniqueid */
-		if ( strcasecmp (type, SLAPI_ATTR_UNIQUEID) == 0 ){
-
+		if ((typelen == SLAPI_ATTR_UNIQUEID_LENGTH) && (PL_strcasecmp (type, SLAPI_ATTR_UNIQUEID) == 0)) {
 			if (e->e_uniqueid != NULL){
 				LDAPDebug (LDAP_DEBUG_TRACE, 
 						   "str2entry_dupcheck: entry has multiple uniqueids %s "
-- 
1.8.1.4